#    $Id: Log.pm,v 1.3 2005/07/03 17:00:57 kevinspicer Exp $
#    MailScanner-MRTG 
#    Copyright (C) 2002-3 Dale Lovelace <dlovelace@hotels.com>
#    With various bits shamelessly stolen from others
#    Restructuring and Substantial Modifications 
#    Copyright (C) 2003-5 Kevin Spicer <kevin@kevinspicer.co.uk>
#    with contributions from many other (see CHANGELOG for details)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#   Please submit all bug reports, patches etc via the sourceforge project 
#   page at http://sourceforge.net/projects/mailscannermrtg
#
#

package MSMRTG::Log;
require Exporter;
use Sys::Syslog;

@ISA=qw(Exporter);
@EXPORT=qw(Log_Syslog);

$log_open=0;

sub Log_Syslog {
	my $facility=shift();
	my $fatal=shift();
	my $message=shift();
	my $method="stderr";
	if (defined($MSMRTG::Config::Config{'loggingmethod'} &&
		$MSMRTG::Config::Config{'loggingmethod'} =~ /stderr|syslog/ )) {
		$method=$MSMRTG::Config::Config{'loggingmethod'};
	}
	# Check if we need to write to stderr
	if ($method =~ /stderr/i) {
		print STDERR $message;
	}
	# If not writing to stderr, but debugging we _do_ need to write the message
	elsif ($MSMRTG::Debug::debug) { MSMRTG::Debug::Debug($message)}
	# If we are logging to syslog...
	if ($method =~ /syslog/i) {
		if (!$log_open) {Open_Syslog()};
		syslog($facility, $message);
		if ($fatal) {closelog()}
	} 
	if ($fatal) {exit(1)}
	return;
}

sub Open_Syslog {
	my $error=0;
	my $facility='mail';
	# Check a valid facility is specified, if not use mail (above)
	if ($MSMRTG::Config::Config{'syslogfacility'} =~ /^mail|user|local[0-7]$/i ) {
		$facility = lc ($MSMRTG::Config::Config{'syslogfacility'});
	} else {
		$error=1;
	}
	# Open the log
	openlog('MailScanner-MRTG', 'cons,pid', $MSMRTG::Config::Config{'syslogfacility'});
	$log_open=1;

	# Check if there was an error in the config file
	if ($error) { Log_Syslog("warning",0,"Syslog facility in MailScanner-MRTG.conf invalid, using $facility instead.") }
	return;
}
1;
